﻿using System;

namespace TestCommon
{
    public class ErrorEventArgs : EventArgs
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 연결 정보
        /// </summary>
        private ConnectionInfo connectionInfo;

        /// <summary>
        /// 구독 정보
        /// </summary>
        private SubscriptionInfo subscriptionInfo;

        /// <summary>
        /// 에러
        /// </summary>
        private string error;

        #endregion
 
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 연결 정보 - ConnectionInfo

        /// <summary>
        /// 연결 정보
        /// </summary>
        public ConnectionInfo ConnectionInfo
        {
            get
            {
                return this.connectionInfo;
            }
        }

        #endregion
        #region 구독 정보 - SubscriptionInfo

        /// <summary>
        /// 구독 정보
        /// </summary>
        public SubscriptionInfo SubscriptionInfo
        {
            get
            {
                return this.subscriptionInfo;
            }
        }

        #endregion
        #region 에러 - Error

        /// <summary>
        /// 에러
        /// </summary>
        public string Error
        {
            get
            {
                return this.error;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ErrorEventArgs(connectionInfo, subscriptionInfo, error)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="connectionInfo">연결 정보</param>
        public ErrorEventArgs(ConnectionInfo connectionInfo, SubscriptionInfo subscriptionInfo, string error)
        {
            this.connectionInfo   = connectionInfo;
            this.subscriptionInfo = subscriptionInfo;
            this.error            = error;
        }

        #endregion
    }
}