﻿using System;

namespace TestCommon
{
    /// <summary>
    /// 서버 재연결시 이벤트 인자
    /// </summary>
    public class ServerReconnectedEventArgs : EventArgs
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 연결 정보
        /// </summary>
        private ConnectionInfo connectionInfo;

        #endregion
 
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 연결 정보 - ConnectionInfo

        /// <summary>
        /// 연결 정보
        /// </summary>
        public ConnectionInfo ConnectionInfo
        {
            get
            {
                return this.connectionInfo;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ServerReconnectedEventArgs(connectionInfo)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="connectionInfo">연결 정보</param>
        public ServerReconnectedEventArgs(ConnectionInfo connectionInfo)
        {
            this.connectionInfo = connectionInfo;
        }

        #endregion
    }
}