﻿using System;
using System.Text;

using TestCommon;

namespace TestReceiver
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            MessageClient client = new MessageClient();

            ServerInfo serverInfo = new ServerInfo("127.0.0.1:4222", null, null, 2000, null);

            SubscriptionInfo[] subscriptionInfoArray = new SubscriptionInfo[] { new SubscriptionInfo("foo", null) };

            client.MessageReceived += client_MessageReceived;

            client.Initialize(serverInfo, subscriptionInfoArray);

            Console.WriteLine("수신 메시지 클라인트를 초기화 했습니다.");

            client.Start();

            Console.WriteLine("수신 메시지 클라이언트를 시작했습니다.");

            Console.WriteLine("프로그램을 종료하기 위해 아무 키나 눌러 주시기 바랍니다.");

            Console.ReadKey(false);

            client.Stop();

            Console.WriteLine("수신 메시지 클라이언트를 중단했습니다.");
        }

        #endregion

        #region 클라이언트 메시지 수신시 처리하기 - client_MessageReceived(sender, e)

        /// <summary>
        /// 클라이언트 메시지 수신시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private static void client_MessageReceived(object sender, MessageReceivedEventArgs e)
        {
            Console.WriteLine("수신 서브젝트 : {0}", e.Subject     );
            Console.WriteLine("응답 서브젝트 : {0}", e.ReplySubject);

            if(!string.IsNullOrEmpty(e.ReplySubject))
            {
                e.ReplyMessageByteArray = Encoding.UTF8.GetBytes("응답 메시지 : " + DateTime.Now.ToString());
            }
        }

        #endregion
    }
}